package de.unima.ki.pi2.ptest.aufgabe2.test;

import static org.junit.Assert.*;

import org.junit.Before;
import org.junit.Test;

import de.unima.ki.pi2.ptest.aufgabe2.api.CharCounter;
import de.unima.ki.pi2.ptest.aufgabe2.impl.CharCounterImpl;

public class CharCounterTest {
	
	private CharCounter counter;
	
	@Before
	public void init(){ 
		this.counter = new CharCounterImpl();
	}

	@Test
	public void test0() {
		this.counter.parse("");
		assertEquals(0, this.counter.getNumOfChars('a'));
	}
	
	@Test
	public void test1() {
		this.counter.parse("a");
		assertEquals(1, this.counter.getNumOfChars('a'));
	}
	
	@Test
	public void test2() {
		this.counter.parse("abc");
		assertEquals(1, this.counter.getNumOfChars('a'));
		assertEquals(1, this.counter.getNumOfChars('b'));
		assertEquals(1, this.counter.getNumOfChars('c'));
		assertEquals(0, this.counter.getNumOfChars('d'));
	}
	
	@Test
	public void test3() {
		this.counter.parse("when my mind momentarily threatens to reach beyond to the other");
		assertEquals(4, this.counter.getNumOfChars('m'));
		assertEquals(8, this.counter.getNumOfChars('e'));
		assertEquals(0, this.counter.getNumOfChars('x'));
	}
	
	@Test
	public void test4() {
		this.counter.parse("this text contains empty spaces");
		assertEquals(4, this.counter.getNumOfChars(' '));
	}
	
	@Test
	public void test5() {
		this.counter.parse("aaa");
		this.counter.parse("abbb");
		assertEquals(1, this.counter.getNumOfChars('a'));
	}

	/*
	@Test
	public void testNEW() {
		this.counter.parse("ueber den sieben bergen bei den sieben zwergen");
		assertEquals(13, this.counter.getNumOfChars('e'));
	}
	*/
	
	
	
	
	

}
