package de.unima.ki.pi2.ptest.aufgabe4.test;

import static junitx.framework.ArrayAssert.assertEquals;
import static junit.framework.Assert.assertEquals;

import org.junit.Before;
import org.junit.Test;

import de.unima.ki.pi2.ptest.aufgabe4.api.HammingCode;
import de.unima.ki.pi2.ptest.aufgabe4.impl.HammingCodeImpl;

public class HammingCodeTest {
	
	private HammingCode hc;
	
	private boolean[] data1;
	private boolean[] data2;
	private boolean[] data3;
	private boolean[] data4;
	
	@Before
	public void init(){ 
		this.hc = new HammingCodeImpl();
		this.data1 = new boolean[]{false, false, false, false};
		this.data2 = new boolean[]{true, true, true, true};
		this.data3 = new boolean[]{true, true, false, false};
		this.data4 = new boolean[]{false, true, false, true};
	}

	@Test
	public void simpleTest1() {
		assertEquals(data1, this.hc.decode(this.hc.encode(this.data1)));
	}
	
	@Test
	public void simpleTest2() {
		assertEquals(data2, this.hc.decode(this.hc.encode(this.data2)));
	}
	
	@Test
	public void simpleTest3() {
		assertEquals(data3, this.hc.decode(this.hc.encode(this.data3)));
	}
	
	@Test
	public void simpleTest4() {
		assertEquals(data4, this.hc.decode(this.hc.encode(this.data4)));
	}
	
	
	@Test
	public void transmissionErrorTest1() {
		for (int i = 0; i < 7; i++) {
			boolean[] encoded = this.hc.encode(this.data1);
			encoded[i] = !encoded[i];
			assertEquals(data1, this.hc.decode(encoded));
		}
	}
	
	
	@Test
	public void transmissionErrorTest2() {
		for (int i = 0; i < 7; i++) {
			boolean[] encoded = this.hc.encode(this.data2);
			encoded[i] = !encoded[i];
			assertEquals(data2, this.hc.decode(encoded));
		}
	}
	
	@Test
	public void transmissionErrorTest3() {
		for (int i = 0; i < 7; i++) {
			boolean[] encoded = this.hc.encode(this.data3);
			encoded[i] = !encoded[i];
			assertEquals(data3, this.hc.decode(encoded));
		}
	}
	
	
	@Test
	public void transmissionErrorTest4() {
		for (int i = 0; i < 7; i++) {
			boolean[] encoded = this.hc.encode(this.data4);
			encoded[i] = !encoded[i];
			assertEquals(data4, this.hc.decode(encoded));
		}
	}
	
	
}
